diff -crBPN --exclude=wp-config.php --exclude=.htaccess-inst --exclude=wordpress.sql --exclude=.htaccess.inst --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.3.pl ./wordpress-3.2.1/wp-admin/includes/update-core.php ./wordpress-3.3/wp-admin/includes/update-core.php
*** ./wordpress-3.2.1/wp-admin/includes/update-core.php	2011-11-24 20:39:26.000000000 -0600
--- ./wordpress-3.3/wp-admin/includes/update-core.php	2011-12-12 14:24:19.000000000 -0600
***************
*** 252,258 ****
  'wp-admin/js/list-table.js',
  'wp-admin/js/list-table.dev.js',
  'wp-admin/images/logo-login.gif',
! 'wp-admin/images/star.gif'
  );
  
  /**
--- 252,329 ----
  'wp-admin/js/list-table.js',
  'wp-admin/js/list-table.dev.js',
  'wp-admin/images/logo-login.gif',
! 'wp-admin/images/star.gif',
! // 3.3
! 'wp-admin/css/colors-classic-rtl.css',
! 'wp-admin/css/colors-classic-rtl.dev.css',
! 'wp-admin/css/colors-fresh-rtl.css',
! 'wp-admin/css/colors-fresh-rtl.dev.css',
! 'wp-admin/css/dashboard-rtl.css',
! 'wp-admin/css/dashboard-rtl.dev.css',
! 'wp-admin/css/dashboard.css',
! 'wp-admin/css/dashboard.dev.css',
! 'wp-admin/css/farbtastic-rtl.css',
! 'wp-admin/css/global-rtl.css',
! 'wp-admin/css/global-rtl.dev.css',
! 'wp-admin/css/global.css',
! 'wp-admin/css/global.dev.css',
! 'wp-admin/css/install-rtl.css',
! 'wp-admin/css/install-rtl.dev.css',
! 'wp-admin/css/login-rtl.css',
! 'wp-admin/css/login-rtl.dev.css',
! 'wp-admin/css/login.css',
! 'wp-admin/css/login.dev.css',
! 'wp-admin/css/ms.css',
! 'wp-admin/css/ms.dev.css',
! 'wp-admin/css/nav-menu-rtl.css',
! 'wp-admin/css/nav-menu-rtl.dev.css',
! 'wp-admin/css/nav-menu.css',
! 'wp-admin/css/nav-menu.dev.css',
! 'wp-admin/css/plugin-install-rtl.css',
! 'wp-admin/css/plugin-install-rtl.dev.css',
! 'wp-admin/css/plugin-install.css',
! 'wp-admin/css/plugin-install.dev.css',
! 'wp-admin/css/press-this-rtl.css',
! 'wp-admin/css/press-this-rtl.dev.css',
! 'wp-admin/css/press-this.css',
! 'wp-admin/css/press-this.dev.css',
! 'wp-admin/css/theme-editor-rtl.css',
! 'wp-admin/css/theme-editor-rtl.dev.css',
! 'wp-admin/css/theme-editor.css',
! 'wp-admin/css/theme-editor.dev.css',
! 'wp-admin/css/theme-install-rtl.css',
! 'wp-admin/css/theme-install-rtl.dev.css',
! 'wp-admin/css/theme-install.css',
! 'wp-admin/css/theme-install.dev.css',
! 'wp-admin/css/widgets-rtl.css',
! 'wp-admin/css/widgets-rtl.dev.css',
! 'wp-admin/css/widgets.css',
! 'wp-admin/css/widgets.dev.css',
! 'wp-admin/includes/internal-linking.php',
! 'wp-includes/images/admin-bar-sprite-rtl.png',
! 'wp-includes/js/jquery/ui.button.js',
! 'wp-includes/js/jquery/ui.core.js',
! 'wp-includes/js/jquery/ui.dialog.js',
! 'wp-includes/js/jquery/ui.draggable.js',
! 'wp-includes/js/jquery/ui.droppable.js',
! 'wp-includes/js/jquery/ui.mouse.js',
! 'wp-includes/js/jquery/ui.position.js',
! 'wp-includes/js/jquery/ui.resizable.js',
! 'wp-includes/js/jquery/ui.selectable.js',
! 'wp-includes/js/jquery/ui.sortable.js',
! 'wp-includes/js/jquery/ui.tabs.js',
! 'wp-includes/js/jquery/ui.widget.js',
! 'wp-includes/js/l10n.dev.js',
! 'wp-includes/js/l10n.js',
! 'wp-includes/js/tinymce/plugins/wplink/css',
! 'wp-includes/js/tinymce/plugins/wplink/img',
! 'wp-includes/js/tinymce/plugins/wplink/js',
! 'wp-includes/js/tinymce/themes/advanced/img/wpicons.png',
! 'wp-includes/js/tinymce/themes/advanced/skins/wp_theme/img/butt2.png',
! 'wp-includes/js/tinymce/themes/advanced/skins/wp_theme/img/button_bg.png',
! 'wp-includes/js/tinymce/themes/advanced/skins/wp_theme/img/down_arrow.gif',
! 'wp-includes/js/tinymce/themes/advanced/skins/wp_theme/img/fade-butt.png',
! 'wp-includes/js/tinymce/themes/advanced/skins/wp_theme/img/separator.gif',
  );
  
  /**
***************
*** 335,343 ****
  	$mysql_version  = $wpdb->db_version();
  	$required_php_version = '5.2.4';
  	$required_mysql_version = '5.0';
! 	$wp_version = '3.2.1';
  	$php_compat     = version_compare( $php_version, $required_php_version, '>=' );
! 	$mysql_compat   = version_compare( $mysql_version, $required_mysql_version, '>=' ) || file_exists( WP_CONTENT_DIR . '/db.php' );
  
  	if ( !$mysql_compat || !$php_compat )
  		$wp_filesystem->delete($from, true);
--- 406,417 ----
  	$mysql_version  = $wpdb->db_version();
  	$required_php_version = '5.2.4';
  	$required_mysql_version = '5.0';
! 	$wp_version = '3.3';
  	$php_compat     = version_compare( $php_version, $required_php_version, '>=' );
! 	if ( file_exists( WP_CONTENT_DIR . '/db.php' ) && empty( $wpdb->is_mysql ) )
! 		$mysql_compat = true;
! 	else
! 		$mysql_compat = version_compare( $mysql_version, $required_mysql_version, '>=' );
  
  	if ( !$mysql_compat || !$php_compat )
  		$wp_filesystem->delete($from, true);
***************
*** 384,390 ****
  			$lang_dir = WP_CONTENT_DIR . '/languages';
  
  		if ( !@is_dir($lang_dir) && 0 === strpos($lang_dir, ABSPATH) ) { // Check the language directory exists first
! 			$wp_filesystem->mkdir($to . str_replace($lang_dir, ABSPATH, ''), FS_CHMOD_DIR); // If it's within the ABSPATH we can handle it here, otherwise they're out of luck.
  			clearstatcache(); // for FTP, Need to clear the stat cache
  		}
  
--- 458,464 ----
  			$lang_dir = WP_CONTENT_DIR . '/languages';
  
  		if ( !@is_dir($lang_dir) && 0 === strpos($lang_dir, ABSPATH) ) { // Check the language directory exists first
! 			$wp_filesystem->mkdir($to . str_replace(ABSPATH, '', $lang_dir), FS_CHMOD_DIR); // If it's within the ABSPATH we can handle it here, otherwise they're out of luck.
  			clearstatcache(); // for FTP, Need to clear the stat cache
  		}
  
***************
*** 462,467 ****
--- 536,546 ----
  
  	// Remove maintenance file, we're done.
  	$wp_filesystem->delete($maintenance_file);
+ 
+ 	// If we made it this far:
+ 	do_action( '_core_updated_successfully', $wp_version );
+ 
+ 	return $wp_version;
  }
  
  /**
***************
*** 519,522 ****
  	return true;
  }
  
! ?>
--- 598,640 ----
  	return true;
  }
  
! /**
!  * Redirect to the About WordPress page after a successful upgrade.
!  *
!  * This function is only needed when the existing install is older than 3.3.0.
!  *
!  * @since 3.3.0
!  *
!  */
! function _redirect_to_about_wordpress( $new_version ) {
! 	global $wp_version, $pagenow, $action;
! 
! 	if ( version_compare( $wp_version, '3.3', '>=' ) )
! 		return;
! 
! 	// Ensure we only run this on the update-core.php page. wp_update_core() could be called in other contexts.
! 	if ( 'update-core.php' != $pagenow )
! 		return;
! 
!  	if ( 'do-core-upgrade' != $action && 'do-core-reinstall' != $action )
!  		return;
! 
! 	// Load the updated default text localization domain for new strings
! 	load_default_textdomain();
! 
! 	// See do_core_upgrade()
! 	show_message( __('WordPress updated successfully') );
! 	show_message( '<span class="hide-if-no-js">' . sprintf( __( 'Welcome to WordPress %1$s. You will be redirected to the About WordPress screen. If not, click <a href="%s">here</a>.' ), $new_version, esc_url( admin_url( 'about.php?updated' ) ) ) . '</span>' );
! 	show_message( '<span class="hide-if-js">' . sprintf( __( 'Welcome to WordPress %1$s. <a href="%2$s">Learn more</a>.' ), $new_version, esc_url( admin_url( 'about.php?updated' ) ) ) . '</span>' );
! 	echo '</div>';
! 	?>
! <script type="text/javascript">
! window.location = '<?php echo admin_url( 'about.php?updated' ); ?>';
! </script>
! 	<?php
! 
! 	// Include admin-footer.php and exit
! 	include(ABSPATH . 'wp-admin/admin-footer.php');
! 	exit();
! }
! add_action( '_core_updated_successfully', '_redirect_to_about_wordpress' );
diff -crBPN --exclude=wp-config.php --exclude=.htaccess-inst --exclude=wordpress.sql --exclude=.htaccess.inst --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.3.pl ./wordpress-3.2.1/wp-admin/includes/update.php ./wordpress-3.3/wp-admin/includes/update.php
*** ./wordpress-3.2.1/wp-admin/includes/update.php	2011-11-24 20:39:26.000000000 -0600
--- ./wordpress-3.3/wp-admin/includes/update.php	2011-09-30 12:31:52.000000000 -0500
***************
*** 26,32 ****
   * Get available core updates
   *
   * @param array $options Set $options['dismissed'] to true to show dismissed upgrades too,
!  * 	set $options['available'] to false to skip not-dimissed updates.
   * @return array Array of the update objects
   */
  function get_core_updates( $options = array() ) {
--- 26,32 ----
   * Get available core updates
   *
   * @param array $options Set $options['dismissed'] to true to show dismissed upgrades too,
!  * 	set $options['available'] to false to skip not-dismissed updates.
   * @return array Array of the update objects
   */
  function get_core_updates( $options = array() ) {
***************
*** 82,90 ****
  }
  
  function core_update_footer( $msg = '' ) {
- 	if ( is_multisite() && !current_user_can('update_core') )
- 		return false;
- 
  	if ( !current_user_can('update_core') )
  		return sprintf( __( 'Version %s' ), $GLOBALS['wp_version'] );
  
--- 82,87 ----
***************
*** 140,154 ****
  
  // Called directly from dashboard
  function update_right_now_message() {
- 	if ( is_multisite() && !current_user_can('update_core') )
- 		return false;
- 
- 	$cur = get_preferred_from_update_core();
- 
  	$msg = sprintf( __('You are using <span class="b">WordPress %s</span>.'), $GLOBALS['wp_version'] );
  
! 	if ( isset( $cur->response ) && $cur->response == 'upgrade' && current_user_can('update_core') ) {
! 		$msg .= " <a href='" . network_admin_url( 'update-core.php' ) . "' class='button'>" . sprintf( __('Update to %s'), $cur->current ? $cur->current : __( 'Latest' ) ) . '</a>';
  	}
  
  	echo "<span id='wp-version-message'>$msg</span>";
--- 137,149 ----
  
  // Called directly from dashboard
  function update_right_now_message() {
  	$msg = sprintf( __('You are using <span class="b">WordPress %s</span>.'), $GLOBALS['wp_version'] );
  
! 	if ( current_user_can('update_core') ) {
! 		$cur = get_preferred_from_update_core();
! 
! 		if ( isset( $cur->response ) && $cur->response == 'upgrade'  )
! 			$msg .= " <a href='" . network_admin_url( 'update-core.php' ) . "' class='button'>" . sprintf( __('Update to %s'), $cur->current ? $cur->current : __( 'Latest' ) ) . '</a>';
  	}
  
  	echo "<span id='wp-version-message'>$msg</span>";
